
-- Author: Ian898
-- Date: 27/08/2018

palletSell = {};
palletSell.BONUS = 1; -- 100%

function palletSell:addFillLevelFromTool(object, fillDelta, fillType, toolType)
    local changed = 0
    if fillDelta > 0 then
        local tipTriggerTarget = nil
        if self.tipTriggerTargets == nil then
            self:sellFillType(fillDelta, fillType, toolType)
            changed = fillDelta
        else
            for target,_ in pairs(self.tipTriggerTargets) do
                if target:allowFillType(fillType) and target:getFreeCapacity(fillType) > 0 then
                    if tipTriggerTarget == nil then
                        tipTriggerTarget = target
                    end
                    local maxFillDelta = math.min(fillDelta - changed, target:getFreeCapacity(fillType))
                    changed = changed + maxFillDelta;
                    target:setFillLevel(target:getFillLevel(fillType)+maxFillDelta, fillType, object, self)
                    if changed >= fillDelta then
                        break
                    end
                end
            end
        end
        if g_currentMission.tourIconsBase ~= nil and g_currentMission.tourIconsBase.visible then
            if self.stationName == "StationGrainElevator" and not g_currentMission.tourIconsBase.soldStuffAtGrainElevator then
                g_currentMission.tourIconsBase.soldStuffAtGrainElevator = true
            end
        end
        for _, listener in pairs(self.updateEventListeners) do
            listener:onUpdateEvent(self, fillDelta, fillType, object, tipTriggerTarget)
        end
    end

    return changed
end

function palletSell:sellFillType(fillDelta, fillType, toolType)
    if not self.priceDropDisabled[fillType] then
        self:doPriceDrop(fillDelta, fillType)
    end
    local desc = FillUtil.fillTypeIndexToDesc[fillType]
    desc.totalAmount = desc.totalAmount + fillDelta
    self.totalReceived[fillType] = self.totalReceived[fillType] + fillDelta	
	local price = fillDelta * self:getEffectiveFillTypePrice(fillType);	
	if toolType == 4 then
		price = price * (1 + palletSell.BONUS)
	end	
    self.totalPaid[fillType] = self.totalPaid[fillType] + price
    self.lastIncomeName = self:getIncomeNameForFillType(fillType)
    g_currentMission:addSharedMoney(price, self.lastIncomeName)
    g_currentMission:addMoneyChange(price, self.moneyChangeId)
    self.lastMoneyChange = 30
end

TipTrigger.addFillLevelFromTool = palletSell.addFillLevelFromTool;
TipTrigger.sellFillType = palletSell.sellFillType;